Unit DE28R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE28RP_p, DE32R_p, DE28RS_p, UTDE12_p;

procedure DE28R(F :Proc_F_DE; M :Integer; var JSTART :Integer;
                HMIN :Real; HMAX :Real; EPS :Real;
                P :Real; var YX :Array of Real; var X :Real;
                var H :Real; var BUL :Boolean;
                var DELTY :Array of Real; var DF :Array of Real;
                var RF :Array of Real; var YP :Array of Real;
                var RY :Array of Real; var RFN :Array of Real;
                var IERR :Integer);

implementation

procedure DE28R(F :Proc_F_DE; M :Integer; var JSTART :Integer;
                HMIN :Real; HMAX :Real; EPS :Real;
                P :Real; var YX :Array of Real; var X :Real;
                var H :Real; var BUL :Boolean;
                var DELTY :Array of Real; var DF :Array of Real;
                var RF :Array of Real; var YP :Array of Real;
                var RY :Array of Real; var RFN :Array of Real;
                var IERR :Integer);
var
L,I,K,IM,JER,K1 :Integer;
EPS1,EPS2,ALP :Real;
BUL1,BUL2 :Boolean;
RX :Array [0..4] of Real;
const
C1 :Real = 0.5;
C2 :Real = 0.4166666666666667;
C3 :Real = 0.375;
C4 :Real = -0.02638888888888889;
C5 :Real = 14.21052631578947;
C6 :Real = 0.03125;
IORDER :Integer = 5;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26;
begin
L := 1;
BUL1 := False;
EPS1 := C5*EPS;
EPS2 := C6*EPS;
if ( JSTART >= 0 )
 then goto _3;
IM := 0;
if ( IERR = 0 )
 then goto _1;
IERR := 0;
goto _5;
_1:
ALP := _COM28R.elm1/_COM28R.elm2;
if ( ALP = 0.5 )
 then DE28RP(M,IORDER,ALP,DF);
_COM28R.elm2 := _COM28R.elm1;
for K:=1 to 4 do
 begin
  K1 := K+1;
  for I:=1 to M do
   begin
    DF[(I-1)+(K-1)*M] := DF[(I-1)+(K-1)*M]-DF[(I-1)+(K1-1)*M];
_2:
   end;
 end;
goto _5;
_3:
_COM28R.elm3 := X;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_4:
 end;
IERR := 0;
if ( JSTART <> 0 )
 then goto _5;
IM := 0;
F(X,YX,RF,M);
DE32R(F,M,IORDER,X,YX,HMIN,EPS,P,H,DF,RX,RY,BUL,
     RFN,RF,DELTY,JER);
if ( JER = 0 )
 then goto _6;
IERR := 66;
goto _26;
_5:
if ( H = _COM28R.elm2 )
 then goto _6;
ALP := H/_COM28R.elm2;
DE28RP(M,IORDER,ALP,DF);
_6:
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1]+DF[(I-1)+0*M]+DF[(I-1)+1*M]*C1+DF[(I-1)+2*M]*C2+DF[(I-1)+3*M]*C3;
  RF[I-1] := DF[(I-1)+0*M]+DF[(I-1)+1*M]+DF[(I-1)+2*M]+DF[(I-1)+3*M];
_7:
 end;
X := _COM28R.elm3+H;
_8:
for I:=1 to M do
 begin
  DELTY[I-1] := -RF[I-1]*C3;
_9:
 end;
F(X,YX,RF,M);
BUL2 := True;
for I:=1 to M do
 begin
  RF[I-1] := RF[I-1]*H;
  DELTY[I-1] := DELTY[I-1]+RF[I-1]*C3;
  YX[I-1] := DELTY[I-1]+YX[I-1];
  if ( Abs(YX[I-1]) <= P )
   then goto _10;
  DELTY[I-1] := DELTY[I-1]/YX[I-1];
_10:
  if ( Abs(DELTY[I-1]) > EPS )
   then BUL2 := False;
_11:
 end;
if ( BUL2 )
 then goto _18;
case L of
 1: goto _12;
 2: goto _14;
end;
_12:
for I:=1 to M do
 begin
  if ( Abs(DELTY[I-1]) > EPS1 )
   then goto _14;
_13:
 end;
L := 2;
goto _8;
_14:
if ( not BUL1 ) 
 then goto _15;
IERR := 65;
goto _26;
_15:
H := H*0.5;
BUL := False;
if ( Abs(H) > Abs(HMIN) ) 
 then goto _16;
BUL1 := True;
ALP := Sign(HMIN,H)*0.5/H;
H := Sign(HMIN,H);
goto _17;
_16:
ALP := 0.5;
_17:
DE28RP(M,IORDER,ALP,DF);
IM := 2;
goto _6;
_18:
DE28RS(M,IORDER,RF,DF,DELTY);
_COM28R.elm1 := H;
for I:=1 to M do
 begin
  DELTY[I-1] := DF[(I-1)+4*M]*C4;
  YX[I-1] := YX[I-1]+DELTY[I-1];
_19:
 end;
_20:
for I:=1 to M do
 begin
  DELTY[I-1] := DF[(I-1)+4*M]*C4;
  if ( Abs(YX[I-1]) <= P ) 
   then goto _21;
  DELTY[I-1] := DELTY[I-1]/YX[I-1];
_21:
  if ( Abs(DELTY[I-1]) > EPS2 ) 
   then goto _25;
_22:
 end;
IM := IM+1;
if ( IM <> 3 ) 
 then goto _26;
H := H*2.0;
BUL1 := False;
if ( Abs(H) <= Abs(HMAX) ) 
 then goto _23;
ALP := Sign(HMAX,H)*2.0/H;
H := Sign(HMAX,H);
goto _24;
_23:
ALP := 2.0;
_24:
DE28RP(M,IORDER,ALP,DF);
IM := 0;
goto _20;
_25:
IM := 0;
_26:
if ( IERR <> 0 ) 
 then UTDE12(IERR,28);
JSTART := 1;
_COM28R.elm2 := H;
end;

end.
